searchNodes=[{"doc":"Imports functions from Files, Context and Resolver modules, passing itself as a parameter for configuration.","ref":"Uploadex.html","title":"Uploadex","type":"module"},{"doc":"Context Helper functions for handling files. Note that all functions in this module require the Uploader as an argument. You are free to call them like that: iex&gt; Uploadex.Context . create_with_file ( changeset , Repo , MyUploader ) { :ok , % User { } } However, by doing use Uploadex, repo: Repo in your uploader, you can call these functions directly through the uploader to avoid having to pass these extra arguments around: iex&gt; MyUploader . create_with_file ( changeset ) { :ok , % User { } }","ref":"Uploadex.Context.html","title":"Uploadex.Context","type":"module"},{"doc":"Inserts the changeset and store the record files in a database transaction, so if the files fail to be stored the record will not be created.","ref":"Uploadex.Context.html#create_with_file/4","title":"Uploadex.Context.create_with_file/4","type":"function"},{"doc":"Deletes the record and all of its files. This is not in a database transaction, since the delete operation never returns errors.","ref":"Uploadex.Context.html#delete_with_file/4","title":"Uploadex.Context.delete_with_file/4","type":"function"},{"doc":"Updates the record and its files in a database transaction, so if the files fail to be stored the record will not be created. This function also deletes files that are no longer referenced.","ref":"Uploadex.Context.html#update_with_file/5","title":"Uploadex.Context.update_with_file/5","type":"function"},{"doc":"Similar to update_with_file/3 , but does not delete previous files.","ref":"Uploadex.Context.html#update_with_file_keep_previous/4","title":"Uploadex.Context.update_with_file_keep_previous/4","type":"function"},{"doc":"Process files in Base64","ref":"Uploadex.FileProcessing.html","title":"Uploadex.FileProcessing","type":"module"},{"doc":"If it's in base64, decode it. Otherwise, do not try to process the file.","ref":"Uploadex.FileProcessing.html#process_binary/1","title":"Uploadex.FileProcessing.process_binary/1","type":"function"},{"doc":"","ref":"Uploadex.FileProcessing.html#t:processed_binary/0","title":"Uploadex.FileProcessing.processed_binary/0","type":"type"},{"doc":"Storage for Local Files. Opts directory : String (required for all functions) - Relative to base_path base_path : String (required for all functions) base_url : String (required for Uploadex.Storage.get_url/2 ) To build the URL, base_path will be replaced by base_url . Example To use this storage for your User record, define these functions in your Uploadex.Uploader implementation: def default_opts ( Uploadex.FileStorage ) , do : [ base_path : :code . priv_dir ( :my_app ) , base_url : Endpoint . url ( ) ] def storage ( % User { } = user , :photo ) , do : { Uploadex.FileStorage , directory : &quot;/uploads/users&quot; }","ref":"Uploadex.FileStorage.html","title":"Uploadex.FileStorage","type":"module"},{"doc":"","ref":"Uploadex.FileStorage.html#delete_file_after_delay/2","title":"Uploadex.FileStorage.delete_file_after_delay/2","type":"function"},{"doc":"Functions to store and delete files. Note that all functions in this module require the Uploader as an argument. You are free to call them like that: iex&gt; Uploadex.Files . store_files ( user , MyUploader ) { :ok , % User { } } However, by doing use Uploadex in your uploader, you can call these functions directly through the uploader to avoid having to pass this extra argument around: iex&gt; MyUploader . store_files ( user ) { :ok , % User { } }","ref":"Uploadex.Files.html","title":"Uploadex.Files","type":"module"},{"doc":"Deletes all files for a record.","ref":"Uploadex.Files.html#delete_files/2","title":"Uploadex.Files.delete_files/2","type":"function"},{"doc":"Deletes all files that changed.","ref":"Uploadex.Files.html#delete_previous_files/3","title":"Uploadex.Files.delete_previous_files/3","type":"function"},{"doc":"","ref":"Uploadex.Files.html#get_file_url/4","title":"Uploadex.Files.get_file_url/4","type":"function"},{"doc":"","ref":"Uploadex.Files.html#get_files_url/3","title":"Uploadex.Files.get_files_url/3","type":"function"},{"doc":"","ref":"Uploadex.Files.html#get_files_url/4","title":"Uploadex.Files.get_files_url/4","type":"function"},{"doc":"","ref":"Uploadex.Files.html#get_temporary_file/5","title":"Uploadex.Files.get_temporary_file/5","type":"function"},{"doc":"","ref":"Uploadex.Files.html#get_temporary_files/4","title":"Uploadex.Files.get_temporary_files/4","type":"function"},{"doc":"","ref":"Uploadex.Files.html#get_temporary_files/5","title":"Uploadex.Files.get_temporary_files/5","type":"function"},{"doc":"Stores all files of a record, as defined by the uploader. Files that are not maps are ignored, which allows for assigning an existing file to a record without recreating it, by simply passing it's filename.","ref":"Uploadex.Files.html#store_files/2","title":"Uploadex.Files.store_files/2","type":"function"},{"doc":"","ref":"Uploadex.Files.html#store_files/3","title":"Uploadex.Files.store_files/3","type":"function"},{"doc":"","ref":"Uploadex.Files.html#t:record/0","title":"Uploadex.Files.record/0","type":"type"},{"doc":"","ref":"Uploadex.Files.html#t:record_field/0","title":"Uploadex.Files.record_field/0","type":"type"},{"doc":"","ref":"Uploadex.Files.html#t:status/0","title":"Uploadex.Files.status/0","type":"type"},{"doc":"Resolver functions to make it easier to use Uploadex with Absinthe. Note that all functions in this module require the Uploader as an argument. You are free to call them like that: Example In your Absinthe schema, assuming user only has one photo: object :user do field :photo_url , :string , resolve : Uploadex.Resolver . get_file_url ( :photo , MyUploader ) end If it has many photos: object :user do field :photos , list_of ( :string ) , resolve : Uploadex.Resolver . get_files_url ( :photos , MyUploader ) end However, by doing use Uploadex in your uploader, you can call these functions directly through the uploader to avoid having to pass this extra argument around: Example In your Absinthe schema, assuming user only has one photo: object :user do field :photo_url , :string , resolve : MyUploader . get_file_url ( :photo ) end If it has many photos: object :user do field :photos , list_of ( :string ) , resolve : MyUploader . get_files_url ( :photos ) end","ref":"Uploadex.Resolver.html","title":"Uploadex.Resolver","type":"module"},{"doc":"","ref":"Uploadex.Resolver.html#get_file_url/2","title":"Uploadex.Resolver.get_file_url/2","type":"function"},{"doc":"","ref":"Uploadex.Resolver.html#get_files_url/2","title":"Uploadex.Resolver.get_files_url/2","type":"function"},{"doc":"Storage for AWS S3. Opts bucket : String (required for all functions) region : String (required for Uploadex.Storage.get_url/2 ) directory : String (required for all functions) upload_opts : Keyword list. This opts are passed to ExAws.S3.upload/4 and ExAws.S3.put_object/4 (required for Uploadex.Storage.store/2 ). If content_type is not specified in upload_opts , the default is the upload's content type. Example To use this storage for your User record, define these functions in your Uploadex.Uploader implementation: def default_opts ( Uploadex.S3Storage ) , do : [ bucket : &quot;my_bucket&quot; , region : &quot;sa-east-1&quot; , upload_opts : [ acl : :public_read ] ] def storage ( % User { } = user , :photo ) , do : { Uploadex.S3Storage , directory : &quot;/photos&quot; }","ref":"Uploadex.S3Storage.html","title":"Uploadex.S3Storage","type":"module"},{"doc":"","ref":"Uploadex.S3Storage.html#delete_file_after_delay/2","title":"Uploadex.S3Storage.delete_file_after_delay/2","type":"function"},{"doc":"Behaviour for a Storage implementation.","ref":"Uploadex.Storage.html","title":"Uploadex.Storage","type":"behaviour"},{"doc":"Deletes the file","ref":"Uploadex.Storage.html#c:delete/2","title":"Uploadex.Storage.delete/2","type":"callback"},{"doc":"Returns the path of a temporary file, that will be deleted after the configured amount of time.","ref":"Uploadex.Storage.html#c:get_temporary_file/3","title":"Uploadex.Storage.get_temporary_file/3","type":"callback"},{"doc":"Returns the file's URL","ref":"Uploadex.Storage.html#c:get_url/2","title":"Uploadex.Storage.get_url/2","type":"callback"},{"doc":"Stores the file","ref":"Uploadex.Storage.html#c:store/2","title":"Uploadex.Storage.store/2","type":"callback"},{"doc":"","ref":"Uploadex.Storage.html#t:file/0","title":"Uploadex.Storage.file/0","type":"type"},{"doc":"","ref":"Uploadex.Storage.html#t:opts/0","title":"Uploadex.Storage.opts/0","type":"type"},{"doc":"","ref":"Uploadex.Storage.html#t:record/0","title":"Uploadex.Storage.record/0","type":"type"},{"doc":"","ref":"Uploadex.Storage.html#t:status/0","title":"Uploadex.Storage.status/0","type":"type"},{"doc":"Storage to be used for testing. It holds the files in memory (using a Agent ). Configuring To configure your app to use the Uploadex.TestStorage , just add this storage to your Uploadex module, depending on the current environment: defmodule MyApp.Uploader do use Uploadex @impl true def get_fields ( % User { } ) , do : :files @impl true def default_opts ( Uploadex.FileStorage ) , do : [ ... ] def default_opts ( Uploadex.TestStorage ) , do : [ ] @impl true def storage ( % User { } , _field ) do if test_environment? ( ) do { Uploadex.TestStorage , [ ] } else { Uploadex.FileStorage , [ ... ] } end end @impl true def accepted_extensions ( % User { } , _field ) , do : ~w(.jpg .png) defp test_environment? ( ) do # This env must be set in your config files depending on the environment. Application . fetch_env! ( :my_app , :environment ) == :test end end Using In your ExUnit tests, add a setup block starting the storage: setup do Uploadex.TestStorage . start_link ( ) :ok end Then, in the tests, you can use the get_stored/1 , get_deleted/1 and get_opts : test &quot;some test with files&quot; do assert [ &quot;document-1.pdf&quot; , &quot;document-2.pdf&quot; ] == Uploadex.TestStorage . get_stored ( ) assert [ &quot;deleted-document.pdf&quot; ] == Uploadex.TestStorage . get_deleted ( ) assert [ ] == Uploadex.TestStorage . get_opts ( ) end This module is just the base for testing, check Uploadex.Testing for a more convenient way to test uploads.","ref":"Uploadex.TestStorage.html","title":"Uploadex.TestStorage","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Uploadex.TestStorage.html#child_spec/1","title":"Uploadex.TestStorage.child_spec/1","type":"function"},{"doc":"","ref":"Uploadex.TestStorage.html#get_deleted/1","title":"Uploadex.TestStorage.get_deleted/1","type":"function"},{"doc":"","ref":"Uploadex.TestStorage.html#get_opts/1","title":"Uploadex.TestStorage.get_opts/1","type":"function"},{"doc":"","ref":"Uploadex.TestStorage.html#get_stored/1","title":"Uploadex.TestStorage.get_stored/1","type":"function"},{"doc":"","ref":"Uploadex.TestStorage.html#start_link/1","title":"Uploadex.TestStorage.start_link/1","type":"function"},{"doc":"This module simplifies testing and assertions involving Uploadex . Usage in Tests The most convenient way to use Uploadex.Testing is to use the module: use Uploadex.Testing That will define all the helper functions you'll need to make assertions. Some examples of how to use the functions # Asserting that 2 files were stored assert_stored_files_count ( 2 ) # Asserting the filenames of the stored files assert_stored_files ( [ &quot;file1.pdf&quot; , &quot;file2.pdf&quot; ] ) # Asserting the filenames of the stored files ignoring the order assert_stored_files ( [ &quot;file2.pdf&quot; , &quot;file1.pdf&quot; ] , ignore_order : true ) # Asserting that no file was stored refute_stored_files ( ) # Getting all stored files [ &quot;file1.pdf&quot; , &quot;file2.pdf&quot; ] == get_stored_files ( ) # Asserting that 1 files was deleted assert_deleted_files_count ( 1 ) # Asserting the filenames of the deleted files assert_deleted ( [ &quot;file3.pdf&quot; , &quot;file4.pdf&quot; , &quot;file5.pdf&quot; ] ) # Asserting the filenames of the deleted files ignoring the order assert_deleted_files ( [ &quot;file4.pdf&quot; , &quot;file5.pdf&quot; , &quot;file3.pdf&quot; ] , ignore_order : true ) # Asserting that no file was deleted refute_deleted_files ( ) # Getting all deleted files [ &quot;file3.pdf&quot; , &quot;file4.pdf&quot; , &quot;file5.pdf&quot; ] == get_deleted_files ( ) If you need a more low level API, you can directly use the Uploadex.TestStorage functions.","ref":"Uploadex.Testing.html","title":"Uploadex.Testing","type":"module"},{"doc":"Imports all functions from Uploadex.Testing and defines a setup callback to start the Uploadex.TestStorage .","ref":"Uploadex.Testing.html#__using__/1","title":"Uploadex.Testing.__using__/1","type":"macro"},{"doc":"Asserts that all the files in expected_files were deleted in the exact order that they are passed in the list. Options ignoring_order : if true , ignores the order of the files when asserting (defaults to false )","ref":"Uploadex.Testing.html#assert_deleted_files/2","title":"Uploadex.Testing.assert_deleted_files/2","type":"function"},{"doc":"Asserts that the given expected_count number of files was deleted.","ref":"Uploadex.Testing.html#assert_deleted_files_count/1","title":"Uploadex.Testing.assert_deleted_files_count/1","type":"function"},{"doc":"Asserts that all the files in expected_files were stored in the exact order that they are passed in the list. Options ignoring_order : if true , ignores the order of the files when asserting (defaults to false )","ref":"Uploadex.Testing.html#assert_stored_files/2","title":"Uploadex.Testing.assert_stored_files/2","type":"function"},{"doc":"Asserts that the given expected_count number of files was stored.","ref":"Uploadex.Testing.html#assert_stored_files_count/1","title":"Uploadex.Testing.assert_stored_files_count/1","type":"function"},{"doc":"Returns all the deleted files. It's the same as calling Uploadex.TestStorage.get_deleted/0 .","ref":"Uploadex.Testing.html#get_deleted_files/0","title":"Uploadex.Testing.get_deleted_files/0","type":"function"},{"doc":"Returns the options used in the Uploadex.TestStorage . It's the same as calling Uploadex.TestStorage.get_opts/0 .","ref":"Uploadex.Testing.html#get_storage_opts/0","title":"Uploadex.Testing.get_storage_opts/0","type":"function"},{"doc":"Returns all the stored files. It's the same as calling Uploadex.TestStorage.get_stored/0 .","ref":"Uploadex.Testing.html#get_stored_files/0","title":"Uploadex.Testing.get_stored_files/0","type":"function"},{"doc":"Asserts that no file was deleted.","ref":"Uploadex.Testing.html#refute_deleted_files/0","title":"Uploadex.Testing.refute_deleted_files/0","type":"function"},{"doc":"Asserts that no file was stored.","ref":"Uploadex.Testing.html#refute_stored_files/0","title":"Uploadex.Testing.refute_stored_files/0","type":"function"},{"doc":"Starts the Uploadex.TestStorage . After importing it, you can use as a ExUnit setup callback: import Uploadex.Testing setup :start_test_storage","ref":"Uploadex.Testing.html#start_test_storage/1","title":"Uploadex.Testing.start_test_storage/1","type":"function"},{"doc":"Ecto type that handles upload. It stores the filename in the database.","ref":"Uploadex.Upload.html","title":"Uploadex.Upload","type":"module"},{"doc":"","ref":"Uploadex.Upload.html#t:upload_binary/0","title":"Uploadex.Upload.upload_binary/0","type":"type"},{"doc":"","ref":"Uploadex.Upload.html#t:upload_path/0","title":"Uploadex.Upload.upload_path/0","type":"type"},{"doc":"Behaviour of an Uploader. Example defmodule MyApp.Uploader do @moduledoc false @behaviour Uploadex.Uploader alias MyAppWeb.Endpoint @impl true def get_fields ( % User { } ) , do : :photo def get_fields ( % Company { } ) , do : [ :photo ] @impl true def default_opts ( Uploadex.FileStorage ) , do : [ base_path : :code . priv_dir ( :my_app ) , base_url : Endpoint . url ( ) ] def default_opts ( Uploadex.S3Storage ) , do : [ bucket : &quot;my_bucket&quot; , region : &quot;sa-east-1&quot; , upload_opts : [ acl : :public_read ] ] @impl true def storage ( % User { id : id } , :photo ) , do : { Uploadex.FileStorage , directory : &quot;/uploads/users/ \#{ id } &quot; } def storage ( % Company { } , :photo ) , do : { Uploadex.S3Storage , directory : &quot;/thumbnails&quot; } # Optional: @impl true def accepted_extensions ( % User { } , _field ) , do : ~w(.jpg .png) def accepted_extensions ( _any , _any ) , do : :any end","ref":"Uploadex.Uploader.html","title":"Uploadex.Uploader","type":"behaviour"},{"doc":"","ref":"Uploadex.Uploader.html#c:accepted_extensions/2","title":"Uploadex.Uploader.accepted_extensions/2","type":"callback"},{"doc":"","ref":"Uploadex.Uploader.html#c:default_opts/1","title":"Uploadex.Uploader.default_opts/1","type":"callback"},{"doc":"","ref":"Uploadex.Uploader.html#c:get_fields/1","title":"Uploadex.Uploader.get_fields/1","type":"callback"},{"doc":"","ref":"Uploadex.Uploader.html#c:storage/2","title":"Uploadex.Uploader.storage/2","type":"callback"},{"doc":"","ref":"Uploadex.Uploader.html#t:file/0","title":"Uploadex.Uploader.file/0","type":"type"},{"doc":"","ref":"Uploadex.Uploader.html#t:record/0","title":"Uploadex.Uploader.record/0","type":"type"},{"doc":"","ref":"Uploadex.Uploader.html#t:record_field/0","title":"Uploadex.Uploader.record_field/0","type":"type"},{"doc":"","ref":"Uploadex.Uploader.html#t:t/0","title":"Uploadex.Uploader.t/0","type":"type"},{"doc":"Uploadex is an Elixir library for handling uploads that integrates well with Ecto , Phoenix and Absinthe . Documentation can be found at https://hexdocs.pm/uploadex .","ref":"readme.html","title":"Uploadex","type":"extras"},{"doc":"In you uploader, change @behaviour Uploadex.Uploader to use Uploadex Remove all config :uploadex from your configuration files Change all direct functions calls from Uploadex.Resolver , Uploadex.Files and Uploadex to your Uploader module","ref":"readme.html#migrating-from-v2-to-v3","title":"Uploadex - Migrating from v2 to v3","type":"extras"},{"doc":"The package can be installed by adding uploadex to your list of dependencies in mix.exs : def deps do [ { :uploadex , &quot;~&gt; 3.0.0&quot; } , # S3 dependencies(required for S3 storage only) { :ex_aws , &quot;~&gt; 2.1&quot; } , { :ex_aws_s3 , &quot;~&gt; 2.0.2&quot; } , { :sweet_xml , &quot;~&gt; 0.6&quot; } , ] end If you don't want to use the release candiate, go to the latest stable version documentation .","ref":"readme.html#installation","title":"Uploadex - Installation","type":"extras"},{"doc":"Follow these steps to use Uploadex: 1: Uploader This library relies heavily on pattern matching for configuration, so the first step is to define your Uploader configuration module: defmodule MyApp.Uploader do @moduledoc false use Uploadex , repo : MyApp.Repo # only necessary if using the functions from Uploadex.Context alias MyAppWeb.Endpoint @impl true def get_fields ( % User { } ) , do : :photo def get_fields ( % Company { } ) , do : [ :photo , :logo ] @impl true def default_opts ( Uploadex.FileStorage ) , do : [ base_path : Path . join ( :code . priv_dir ( :my_app ) , &quot;static/&quot; ) , base_url : Endpoint . url ( ) ] def default_opts ( Uploadex.S3Storage ) , do : [ bucket : &quot;my_bucket&quot; , region : &quot;sa-east-1&quot; , upload_opts : [ acl : :public_read ] ] @impl true def storage ( % User { id : id } , :photo ) , do : { Uploadex.FileStorage , directory : &quot;/uploads/users/ \#{ id } &quot; } def storage ( % Company { id : id } , :photo ) , do : { Uploadex.S3Storage , directory : &quot;/thumbnails/ \#{ id } &quot; } def storage ( % Company { } , :logo ) , do : { Uploadex.S3Storage , directory : &quot;/logos&quot; } # Optional: @impl true def accepted_extensions ( % User { } , :photo ) , do : ~w(.jpg .png) def accepted_extensions ( _any , _field ) , do : :any end This example shows the configuration for the Uploadex.FileStorage and Uploadex.S3Storage implementations, but you are free to implement your own Storage . Note: To avoid too much metaprogramming magic, the use in this module is very simple and, in fact, optional. If you wish to do so, you can just define the @behaviour Uploadex.Uploader instead of the use and then call all lower level modules directly, passing your Uploader module as argument. The use makes life much easier, though! 2: Ecto Migration A string field is required in the database to save the file reference. The example below shows what would be needed to have a field to upload. defmodule MyApp.Repo.Migrations.AddPhotoToUsers do use Ecto.Migration def change do alter table ( :users ) do add :photo , :string end end end 3: Schema In your schema, use the Ecto Type Uploadex.Upload : schema &quot;users&quot; do field :name , :string field :photo , Uploadex.Upload end # No special cast is needed, and casting does not have any side effects. def create_changeset ( % User { } = user , attrs ) do user |&gt; cast ( attrs , [ :name , :photo ] ) end 4: Configuration Depending on which features you are using, you may need extra configurations: Temporary Files If you are using get_temporary_file or get_temporary_files , you need to configure task_after : config :task_after , global_name : TaskAfter S3 Configuration If you are using the S3 adapter, add this to your configuration file. For more information access the ex_aws_s3 documentation : config :ex_aws , :s3 , access_key_id : &quot;key&quot; , secret_access_key : &quot;secret&quot; , region : &quot;us-east-1&quot; , host : &quot;localhost&quot; , port : &quot;9000&quot; , scheme : &quot;http://&quot; config :my_project , :uploads , bucket : &quot;uploads&quot; , region : &quot;us-east-1&quot; 5: Enjoy! Now, you can use your defined Uploader to handle your records with their files! The use Uploadex line in your Uploader module will import 3 groups of functions: Context The highest level functions are context helpers (see Context for more documentation), which will allow you to easily create, update and delete your records with associated files: defmodule MyApp.Accounts do alias MyApp.Accounts.User alias MyApp.MyUploader def create_user ( attrs ) do % User { } |&gt; User . create_changeset ( attrs ) |&gt; MyUploader . create_with_file ( ) end def update_user ( % User { } = user , attrs ) do user |&gt; User . update_changeset ( attrs ) |&gt; MyUploader . update_with_file ( user ) end def delete_user ( % User { } = user ) do MyUploader . delete_with_file ( user ) end end Resolver There are also functions to help you easily fetch the files in Absinthe schemas: object :user do field :photo_url , :string , resolve : MyUploader . get_file_url ( :photo ) end object :user do field :photos , list_of ( :string ) , resolve : MyUploader . get_files_url ( :photos ) end See Resolver for more documentation. Files If you need more flexibility, you can use the lower-level functions defined in Files , which provide some extra functionalities, such as get_temporary_file , useful when the files are not publicly available. Some examples: { :ok , % User { } } = MyUploader . store_files ( user ) { :ok , % User { } } = MyUploader . delete_files ( user ) { :ok , % User { } } = MyUploader . delete_previous_files ( user , user_after_change ) { :ok , files } = MyUploader . get_files_url ( user , :photos )","ref":"readme.html#usage","title":"Uploadex - Usage","type":"extras"},{"doc":"For knowing how to test with Uploadex, check the hexdocs of the Testing module.","ref":"readme.html#testing","title":"Uploadex - Testing","type":"extras"},{"doc":"Even though there already exists a library for uploading files that integrates with ecto ( https://github.com/stavro/arc_ecto ), this library was created because: arc_ecto does not support upload of binary files Uploadex makes it easier to deal with records that contain files without having to manage those files manually on every operation Using uploadex, the changeset operations have no side-effects and no special casting is needed Uploadex offers more flexibility by allowing to define different storage configurations for each struct (or even each field in a struct) in the application Uploadex does not rely on global configuration, which makes it easier to work in umbrella applications","ref":"readme.html#motivation","title":"Uploadex - Motivation","type":"extras"}]